
local M = {}

local nl105
local nl182
local nl44
local nl192
local nl200
local nl32
local nl24
local nl16
local nl6
local nl0
local nl2
local nl20
local nl12
local nl28
local nl36
local nl54
local nl171
local nl188
local nl196
local nl222
local nl224
local nl218
local nl208


local cooldown
local lastCheckedFireValue -- allows using an input device axis as shooting control, not just on/off buttons

local function onReset()
  electrics.values['lifter'] = 0
  electrics.values['lifter_input'] = 0
  electrics.values['shoot'] = 0
  cooldown = 0
  lastCheckedFireValue = 0
  for k, node in pairs (v.data.nodes) do
    if node.name == "nl105" then nl105=k  end
    if node.name == "nl182" then nl182=k  end
    if node.name == "nl44" then nl44=k  end	
    if node.name == "nl192" then nl192=k  end	
    if node.name == "nl200" then nl200=k  end	
    if node.name == "nl32" then nl32=k  end	
    if node.name == "nl24" then nl24=k  end		
    if node.name == "nl16" then nl16=k  end			
    if node.name == "nl6" then nl6=k  end		
    if node.name == "nl0" then nl0=k  end	
    if node.name == "nl2" then nl2=k  end	
    if node.name == "nl20" then nl20=k  end	
    if node.name == "nl12" then nl12=k  end	
    if node.name == "nl28" then nl28=k  end	
    if node.name == "nl36" then nl36=k  end	
    if node.name == "nl54" then nl54=k  end	
    if node.name == "nl171" then nl171=k  end	
    if node.name == "nl188" then nl188=k  end	
    if node.name == "nl196" then nl196=k  end
    if node.name == "nl204" then nl204=k  end	
    if node.name == "nl212" then nl212=k  end
    if node.name == "nl224" then nl224=k  end	
    if node.name == "nl222" then nl222=k  end
    if node.name == "nl218" then nl218=k  end	
    if node.name == "nl208" then nl208=k  end
	
  end
end

local function updateGFX(dt) -- ms
  electrics.values['lifter'] = math.min(1, math.max(-0.0, (electrics.values['lifter'] + electrics.values['lifter_input'] * dt * 0.1)))
  if electrics.values['shoot'] == 0 then
    if math.random(0, 1) < (1+cooldown*0.9) then -- cannon smoke & fire for 500 ms
       obj:addParticleByNodesRelative(nl105, nl105, 1, 81, 0.1, 1)	
       obj:addParticleByNodesRelative(nl182, nl182, 1, 31, 0.1, 1)	   
       obj:addParticleByNodesRelative(nl44, nl44, 1, 51, 0.1, 1)	 
       obj:addParticleByNodesRelative(nl192, nl192, 1, 31, 0.1, 1)	
       obj:addParticleByNodesRelative(nl200, nl200, 1, 51, 0.1, 1)	   	
       obj:addParticleByNodesRelative(nl32, nl32, 1, 31, 0.1, 1)	
       obj:addParticleByNodesRelative(nl24, nl24, 1, 51, 0.1, 1) 	
       obj:addParticleByNodesRelative(nl16, nl16, 1, 31, 0.1, 1) 	
       obj:addParticleByNodesRelative(nl6, nl6, 1, 31, 0.1, 1) 
       obj:addParticleByNodesRelative(nl0, nl0, 1, 51, 0.1, 1) 
       obj:addParticleByNodesRelative(nl2, nl2, 1, 31, 0.1, 1) 
       obj:addParticleByNodesRelative(nl20, nl20, 1, 51, 0.1, 1) 
       obj:addParticleByNodesRelative(nl12, nl12, 1, 31, 0.1, 1) 
       obj:addParticleByNodesRelative(nl28, nl28, 1, 51, 0.1, 1) 
       obj:addParticleByNodesRelative(nl36, nl36, 1, 31, 0.1, 1) 
       obj:addParticleByNodesRelative(nl54, nl54, 1, 51, 0.1, 1) 
       obj:addParticleByNodesRelative(nl171, nl171, 1, 31, 0.1, 1) 
       obj:addParticleByNodesRelative(nl188, nl188, 1, 51, 0.1, 1) 
       obj:addParticleByNodesRelative(nl196, nl196, 1, 31, 0.1, 1) 
      obj:addParticleByNodesRelative(nl204, nl204, 1, 51, 0.1, 1) 
       obj:addParticleByNodesRelative(nl212, nl212, 1, 31, 0.1, 1) 
      obj:addParticleByNodesRelative(nl224, nl224, 1, 51, 0.1, 1) 
       obj:addParticleByNodesRelative(nl222, nl222, 1, 31, 0.1, 1) 
      obj:addParticleByNodesRelative(nl208, nl208, 1, 51, 0.1, 1) 
       obj:addParticleByNodesRelative(nl218, nl218, 1, 31, 0.1, 1) 
	   
    end
    cooldown = cooldown + dt
  end
end



local function liftBarrel(value)
  electrics.values.lifter_input = value
end

-- public interface
M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX
M.fire      = fire
M.liftBarrel = liftBarrel

return M